;;
;; tests.scm
;;
;; Runner of all tests together.
;;
;; ISC License
;;
;; Copyright 2023 Brmlab, z.s.
;; Dominik Pantůček <dominik.pantucek@trustica.cz>
;;
;; Permission to use, copy, modify, and/or distribute this software
;; for any purpose with or without fee is hereby granted, provided
;; that the above copyright notice and this permission notice appear
;; in all copies.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
;; WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
;; WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
;; AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
;; CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
;; OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
;; NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
;; CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

(declare (unit tests))

(module
 tests
 (
  run-all-tests!
  )

 (import scheme
	 listing
	 util-dict-list
	 month
	 period
	 util-list
	 ansi
	 command-line
	 members-dir
	 primes
	 member-record
	 table
	 util-csv
	 util-set-list
	 util-parser)

 (define (run-all-tests!)
   (listing-tests!)
   (ldict-tests!)
   (month-tests!)
   (period-tests!)
   (util-list-tests!)
   (ansi-tests!)
   (command-line-tests!)
   (members-dir-tests!)
   (primes-tests!)
   (member-record-tests!)
   (table-tests!)
   (csv-simple-tests!)
   (lset-tests!)
   (parser-tests!))

 )
